#include <windows.h>
#include <tchar.h>

void SetBackLightChangeEvent()
{
	HANDLE hEvent = CreateEvent( NULL, FALSE, TRUE, _T("BackLightChangeEvent"));
	if (hEvent) {
		SetEvent(hEvent);
		CloseHandle(hEvent);
	}
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR     lpCmdLine,
                     int       nCmdShow )
{
	HKEY hKey;
	DWORD dwSize, dwValue = 0;

	if (_tcslen(lpCmdLine)) {
		SetBackLightChangeEvent();
		return 0;
	}

	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, _T("Software\\Drivers\\VPD"), 
		0, KEY_READ | KEY_WRITE, &hKey) != ERROR_SUCCESS)
		return 0;

	dwSize = sizeof(dwValue);
	if (RegQueryValueEx(hKey, _T("RestricBacklight"), 0, NULL, (LPBYTE)&dwValue, &dwSize) == ERROR_SUCCESS) {
		dwValue = !dwValue;
		RegSetValueEx(hKey, _T("RestricBacklight"), 0, REG_DWORD, (LPBYTE)&dwValue, sizeof(DWORD));
		SetBackLightChangeEvent();
	}
	RegCloseKey(hKey);

	return 0;
}
